; ==============================================
; Wonderland Classic Trilogy Packed Files Definations
; ----------------------------------------------

; Reconstructed from the decompiled RTW code by Lazy Loof
; but should be same for TOW and WSW too.

; Note that "packed files" mean res1.dat and res2.dat that contain the "pack files"
; I'm sorry for such a naming, this was how the pack file related variables 
; were named in RTW Decompiled Code too, so I copied them over. :lol:

; ==============================================

; CONSTANTS
; -------------------------------
Const NULL_PTR = 0 ; used as syntatic sugar to distinguish between normal zeros and Blitz3D objects

; DEFINES
; -------------------------------
Global NofPackFiles = 0 ; total number of pack files
Global PackFileCount = 0 ; current number of pack files used since the game started
Dim PackFileName$(1000) ; names of pack files
Dim PackFilePosition(1000) ; position of pack files
Dim PackFileLength(1000) ; size of pack files


; FUNCTIONS
; -------------------------------

; load the texture from packed files
Function MyLoadTexture(file_name$, flags, unused_variable)
	Local texture_handle = NULL_PTR ;texture
	texture_handle = LoadTexture(Pack(file_name), flags)
	If texture_handle = NULL_PTR Then
		texture_handle = LoadTexture(file_name, flags)
	End If
	If texture_handle = NULL_PTR Then
		GlobalError("Couldn't load Texture: " + file_name + ", Flag " + flags)
	End If
	Return texture_handle
End Function

; load the animtexture from packed files
Function MyLoadAnimTexture(file_name$, flags, frame_width, frame_height, first_frame, frame_count, unused_variable)
	Local texture_handle = NULL_PTR ;animtexture 
	texture_handle = LoadAnimTexture(Pack(file_name), flags, frame_width, frame_height, first_frame, frame_count)
	If texture_handle = NULL_PTR Then
		texture_handle = LoadAnimTexture(file_name, flags, frame_width, frame_height, first_frame, frame_count)
	End If
	If texture_handle = NULL_PTR Then
		GlobalError("Couldn't load AnimTexture: " + file_name)
	End If
	Return texture_handle
End Function

; load the file from packed files
Function MyReadFile(file_name$, unused_variable)
	Local file_handle = NULL_PTR ;file
	If Lower(Left(file_name, 12)) = "levels\bonus" And Right(file_name, 4) = ".lev" Then
		file_handle = ReadFile(Right(file_name, 10))
		If file_handle = NULL_PTR Then
			GlobalError("Couldn't load Bonus Level - Install files in same directory!")
		End If
		Return file_handle
	End If
	file_handle = ReadFile(Pack(file_name))
	If file_handle = NULL_PTR Then
		file_handle = ReadFile(file_name)
	End If
	If file_handle = NULL_PTR Then
		GlobalError("Couldn't load File: " + file_name)
	End If
	Return file_handle
End Function

; load the MD2 model from packed files
Function MyLoadMD2(file_name$, unused_variable)
	Local md2_handle = NULL_PTR ;MD2
	md2_handle = LoadMD2(Pack(file_name), 0)
	If md2_handle = NULL_PTR Then
		md2_handle = LoadMD2(file_name, 0)
	End If
	If md2_handle = NULL_PTR Then
		GlobalError("Couldn't load MD2: " + file_name)
	End If
	Return md2_handle
End Function

; load the mesh from packed files
Function MyLoadMesh(mesh_name$, unused_variable)	
	Local mesh_handle = NULL_PTR ;mesh
	mesh_handle = LoadMesh(Pack(mesh_name), 0)
	If mesh_handle = NULL_PTR Then
		mesh_handle = LoadMesh(mesh_name, 0)
	End If
	If mesh_handle = NULL_PTR Then
		GlobalError("Couldn't load Mesh: " + mesh_name)
	End If
	Return mesh_handle
End Function

; load the sound from packed files
Function MyLoadSound(sound_name$, unused_variable)	
	Local sound_handle = NULL_PTR ;sound
	sound_handle = LoadSound(Pack(sound_name))
	If sound_handle = NULL_PTR Then
		sound_handle = LoadSound(sound_name)
	End If
	If sound_handle = NULL_PTR Then
		DoesSoundExist = False
	End If
	Return sound_handle
End Function

; if failed give error to user and end the game
Function GlobalError(tex$)	
	Print ""
	Print "-----"
	Print "ERROR"
	Print "-----"
	Print tex
	Print ""
	Print "Press Esc to exit."
	Repeat
	Until KeyDown(1) = False
	Repeat
	Until KeyDown(1) = True
	End
End Function

; initialize the packed files
Function InitPackFile()	
	Local file_handle = ReadFile("res1.dat")
	Local index = 0
	Repeat
		PackFileName(index) = Lower(ReadString(file_handle))
		PackFilePosition(index) = ReadInt(file_handle)
		PackFileLength(index) = ReadInt(file_handle)
		index = index + 1
	Until Eof(file_handle)
	NofPackFiles = index
	CloseFile(file_handle)
End Function

; get the file from packed res#.dat
Function Pack$(file_name$)
	Local success = False ; gives information weather the function was successful in fetching the packed file or not
	Local ext$ = "" ; extension of destination temporary file created for loading content
	; get extension
	If Lower(Right(file_name, 4)) = ".3ds" Then
		ext = ".3ds"
	Else If Lower(Right(file_name, 2)) = ".x" Then
		ext = ".x"
	Else
		ext = ".tmp"
	End If
	; now clean any earlier tmp file
	dir_handle = ReadDir(CurrentDir())
	Local next_file$ = ""
	Repeat
		next_file = NextFile(dir_handle)
		If Lower(Right(next_file, 4)) = ".tmp" Or (Lower(Right(next_file, 4)) = ".3ds") Or (Lower(Right(next_file$, 2)) = ".x") Then
			DeleteFile next_file
		End If
	Until next_file = ""
	CloseDir dir_handle	
	; done!
	; get the new file now!
	For i = 0 To NofPackFiles - 1
		If Lower(file_name) = PackFileName(i) Then
			success = True
			in_file_handle = ReadFile("res2.dat")
			out_file_handle = WriteFile(Str(PackFileCount) + ext)
			SeekFile(in_file_handle, PackFilePosition(i))
			For position = 1 To PackFileLength(i)
				WriteByte(out_file_handle, ReadByte(in_file_handle))
			Next
			CloseFile(in_file_handle)
			CloseFile(out_file_handle)
			Exit
		End If
	Next
	PackFileCount = PackFileCount + 1
	If success Then
		Return Str(PackFileCount - 1) + ext
	Else
		Return file_name
	End If
End Function

; ==============================================
; END OF FILE
; ==============================================